package io.zipcoder.interfaces;

public enum Educator implements Teacher {

    KRIS(100, "Kris Younger"),
    DOLIO(101, "Dolio Durant"),
    FROILAN(102, "Froilan Miranda"),
    LEON(103, "Leon Hunter"),
    NHU(104, "Nhu Nguyen"),
    WIL(105, "Wilhem Alcivar"),
    DOM(106, "Dominique Clarke");

    private int idNum;
    private String name;
    private double timeWorked;

    Educator(int idNum, String name) {
        this.idNum = idNum;
        this.name = name;
        this.timeWorked = 0;
    }

    public int getIdNum() { return idNum; }

    public String getName() { return name; }

    public double getTimeWorked() { return timeWorked; }

    public void setTimeWorked(double timeWorked) { this.timeWorked = timeWorked; }

    public void lecture(Learner[] learners, double numOfHours) {
        for (Learner learner : learners) {
            double hours = (numOfHours / learners.length);
            learner.learn(hours);
        }
        setTimeWorked(getTimeWorked() + numOfHours);
    }

    public void teach(Learner learner, double numOfHours) {
        learner.learn(numOfHours);
        setTimeWorked(getTimeWorked() + numOfHours);
    }
}
