package io.zipcoder.interfaces;
import org.junit.Test;
import org.junit.Assert;

public class TestEducator {

    @Test
    public void testImplementation(){
        //Given
        boolean exp = true;
        boolean act = Educator.NHU instanceof Teacher;
        //Then
        Assert.assertEquals(exp,act);
    }

    @Test
    public void testTeach(){
        //Given
        Student stud1 = new Student("newStud1",1);
        //When
        Educator.NHU.setTimeWorked(0);
        Educator.NHU.teach(stud1, 2);
        double exp = 2;
        double act = stud1.getTotalStudyTime();
        //Then
        Assert.assertEquals(exp,act,.1);
    }

    @Test
    public void testLecture(){
        //Given
        Student stud1 = new Student("newStud1",1);
        Student stud2 = new Student("newStud1",2);
        Student[] studs = {stud1, stud2};

        //When
        Educator.NHU.setTimeWorked(0);
        Educator.NHU.lecture(studs,12);
        double exp = 6;
        double act = studs[0].getTotalStudyTime();

        //Then
        Assert.assertEquals(exp,act,.1);
    }

    @Test
    public void testLectureTime(){
        //Given
        Student stud1 = new Student("newStud1",1);
        Student stud2 = new Student("newStud1",2);
        Student[] studs = {stud1, stud2};

        //When
        Educator.NHU.setTimeWorked(0);
        Educator.NHU.lecture(studs,12);
        double exp = 12;
        double act = Educator.NHU.getTimeWorked();

        //Then
        Assert.assertEquals(exp,act,.1);
    }
}
