package io.zipcoder.interfaces;
import org.junit.Assert;
import org.junit.Test;

public class TestPeople {

    Person person1, person2;
    Student stud1;
    Instructor instructor;
    Instructors instructors;
    Students students;

    public TestPeople(){
        students = Students.getInstance();
        instructors = Instructors.getInstance();
        person1 = new Person(333,"person1");
        person2 = new Person(444,"person2");
        stud1 = new Student("stud1",555);
        instructor = new Instructor("Melanie",999);
        students.add(stud1);
    }

    @Test
    public void testAdd(){
        Assert.assertEquals(40,students.getCount());
    }

    @Test
    public void testRemoveByPerson(){
        students.removeByPerson(stud1);
        Assert.assertEquals(39,students.getCount());
    }

    @Test
    public void testRemoveById(){
        //When
        students.removeById(555);
        //Then
        Assert.assertEquals(40,students.getCount());
    }

    @Test
    public void testFindById(){
        //When
        Student exp = students.findById(555);
        //Then
        Assert.assertEquals(exp.getId(),stud1.getId());

    }

    @Test
    public void testRemoveAll(){
        //Given
        Instructors instructors = Instructors.getInstance();
        //When
        instructors.removeAll();
        //Then
        Assert.assertEquals(0,instructors.getCount());
    }
}
